#!/bin/sh
#
echo "syncing disk" > /dev/dbox/fp0
sync
echo "kill rcS" > /dev/dbox/fp0
sleep 1
killall -9 rcS
echo "kill enigma2" > /dev/dbox/fp0
killall -9 enigma2
sleep 8
echo "touch firstboot" > /dev/dbox/fp0
touch /var/etc/.firstboot
sleep 1
echo "Waiting" > /dev/dbox/fp0
sleep 2

if [ -e /etc/init.d/umount.sh ]; then
	/etc/init.d/umount.sh
	sleep 10
else
	echo "UMOUNT ERROR" > /dev/dbox/fp0
	sleep 2
	echo "PLEASE" > /dev/dbox/fp0
	sleep 2
	echo "INSTALL" > /dev/dbox/fp0
	sleep 2
	echo "AUTOMOUNT v1.4" > /dev/dbox/fp0
        sleep 3
fi
sleep 2
echo "Backup started" > /dev/dbox/fp0	

## create media execlude list

TMP=.tmp
EXECLUDLIST=.execludlist
echo "" > $TMP
echo "" > $EXECLUDLIST

ls -1 /media > $TMP
LIST=`cat $TMP`

for ROUND in $LIST; do
        echo " --exclude=/media/$ROUND/*" >> $EXECLUDLIST
        sed '/^ *$/d' -i $EXECLUDLIST

done
EXECLUDMEDIA=`cat $EXECLUDLIST | tr -d '\n' | sed 's/*/* /'`
rm $EXECLUDLIST
rm $TMP

## create mnt execlude list

TMP=.tmp
EXECLUDLIST=.execludlist
echo "" > $TMP
echo "" > $EXECLUDLIST

ls -1 /mnt > $TMP
LIST=`cat $TMP`

for ROUND in $LIST; do
        echo " --exclude=/mnt/$ROUND/*" >> $EXECLUDLIST
        sed '/^ *$/d' -i $EXECLUDLIST

done
EXECLUDMNT=`cat $EXECLUDLIST | tr -d '\n' | sed 's/*/* /'`
rm $EXECLUDLIST
rm $TMP

## create hdd execlude list

TMP=.tmp
EXECLUDLIST=.execludlist
echo "" > $TMP
echo "" > $EXECLUDLIST

ls -1 /hdd > $TMP
LIST=`cat $TMP`

for ROUND in $LIST; do
        echo  " --exclude=/hdd/$ROUND/*" >> $EXECLUDLIST
        sed '/^ *$/d' -i $EXECLUDLIST

done
EXECLUDHDD=`cat $EXECLUDLIST | tr -d '\n' | sed 's/*/* /'`
rm $EXECLUDLIST
rm $TMP

##
echo "| BACKUP"
echo "|"
echo "| KOMPRESS      : czf"
echo "| EXECLUD-SELF  : --exclude=`date +"%Y.%m.%d_%H.%M.%S"`_backup.e2.tar.gz"
echo "| EXECLUD-FILE  : --exclude=.execludlist --exclude=.tmp --exclude=swapfile" 
echo "| EXECLUD-SYS   : --exclude=sys/* --exclude=proc/* --exclude=tmp/* --exclude=ram/* --exclude=dev/* --exclude=dev.static/*"
echo "| EXECLUD-HDD   : $EXECLUDHDD"
echo "| EXECLUD-MNT   : $EXECLUDMNT"
echo "| EXECLUD-MEDIA : $EXECLUDMEDIA"
echo "| ADD-LIST      : --add-file=/dev/MAKEDEV /"
echo "|"
echo "| Backup started"

/usr/lib/enigma2/python/Plugins/Extensions/BackUp/tar czf /root/`date +"%Y.%m.%d_%H.%M.%S"`_backup.e2.tar.gz --exclude=`date +"%Y.%m.%d_%H.%M.%S"`_backup.e2.tar.gz --exclude=.execludlist --exclude=.tmp --exclude=swapfile --exclude=sys/* --exclude=proc/* --exclude=tmp/* --exclude=ram/* --exclude=dev/* --exclude=dev.static/* $EXECLUDHDD $EXECLUDMNT $EXECLUDMEDIA --add-file=/dev/MAKEDEV /
echo "| Backup done"
echo "remove firstboot" > /dev/dbox/fp0
rm /var/etc/.firstboot
echo "syncing disk" > /dev/dbox/fp0
sync
sleep 2
echo "Backup ready"
echo "Backup ready" > /dev/dbox/fp0
sleep 2
number=`ls -l /root/ | wc -l`

until false
do
	count=`ls -l /root/ | wc -l`
	if [ "$number" = "$count" ]; then
		echo "Waiting" > /dev/dbox/fp0
		sleep 2
		echo "Please Remove" > /dev/dbox/fp0
		sleep 2
		echo "You Backup" > /dev/dbox/fp0
		sleep 2
		echo "FTP / SAMBA" > /dev/dbox/fp0
		sleep 2
		echo "Finished !" > /dev/dbox/fp0
		sleep 2
	else
		echo "syncing disk" > /dev/dbox/fp0
		sync
		sleep 2
		echo "Thanks" > /dev/dbox/fp0
		sleep 2
		echo "Rebooting now"
		echo "Rebooting now" > /dev/dbox/fp0
		reboot -f
	fi
done

echo "done"